diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/mac-tx-middle.cc ns-3.40/src/wifi/model/mac-tx-middle.cc
--- ns-3.39/src/wifi/model/mac-tx-middle.cc	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/mac-tx-middle.cc	2023-09-27 13:30:37.906839800 -0700
@@ -40,9 +40,7 @@
 MacTxMiddle::~MacTxMiddle()
 {
     NS_LOG_FUNCTION(this);
-    for (std::map<Mac48Address, uint16_t*>::const_iterator i = m_qosSequences.begin();
-         i != m_qosSequences.end();
-         i++)
+    for (auto i = m_qosSequences.begin(); i != m_qosSequences.end(); i++)
     {
         delete[] i->second;
     }
@@ -57,7 +55,7 @@
     {
         uint8_t tid = hdr->GetQosTid();
         NS_ASSERT(tid < 16);
-        std::map<Mac48Address, uint16_t*>::const_iterator it = m_qosSequences.find(hdr->GetAddr1());
+        auto it = m_qosSequences.find(hdr->GetAddr1());
         if (it != m_qosSequences.end())
         {
             retval = it->second[tid];
@@ -68,8 +66,7 @@
         {
             retval = 0;
             std::pair<Mac48Address, uint16_t*> newSeq(hdr->GetAddr1(), new uint16_t[16]);
-            std::pair<std::map<Mac48Address, uint16_t*>::const_iterator, bool> newIns =
-                m_qosSequences.insert(newSeq);
+            auto newIns = m_qosSequences.insert(newSeq);
             NS_ASSERT(newIns.second == true);
             for (uint8_t i = 0; i < 16; i++)
             {
@@ -96,7 +93,7 @@
     {
         uint8_t tid = hdr->GetQosTid();
         NS_ASSERT(tid < 16);
-        std::map<Mac48Address, uint16_t*>::const_iterator it = m_qosSequences.find(hdr->GetAddr1());
+        auto it = m_qosSequences.find(hdr->GetAddr1());
         if (it != m_qosSequences.end())
         {
             retval = it->second[tid];
@@ -119,7 +116,7 @@
     NS_LOG_FUNCTION(this);
     NS_ASSERT(tid < 16);
     uint16_t seq = 0;
-    std::map<Mac48Address, uint16_t*>::const_iterator it = m_qosSequences.find(addr);
+    auto it = m_qosSequences.find(addr);
     if (it != m_qosSequences.end())
     {
         return it->second[tid];
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/mgt-headers.cc ns-3.40/src/wifi/model/mgt-headers.cc
--- ns-3.39/src/wifi/model/mgt-headers.cc	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/mgt-headers.cc	2023-09-27 13:30:37.906839800 -0700
@@ -1688,7 +1688,7 @@
 MgtDelBaHeader::GetTid() const
 {
     NS_ASSERT(m_tid < 16);
-    uint8_t tid = static_cast<uint8_t>(m_tid);
+    auto tid = static_cast<uint8_t>(m_tid);
     return tid;
 }
 
@@ -1731,26 +1731,26 @@
  *     EMLSR Operating Mode Notification
  ****************************************************/
 
-NS_OBJECT_ENSURE_REGISTERED(MgtEmlOperatingModeNotification);
+NS_OBJECT_ENSURE_REGISTERED(MgtEmlOmn);
 
 TypeId
-MgtEmlOperatingModeNotification::GetTypeId()
+MgtEmlOmn::GetTypeId()
 {
     static TypeId tid = TypeId("ns3::MgtEmlOperatingModeNotification")
                             .SetParent<Header>()
                             .SetGroupName("Wifi")
-                            .AddConstructor<MgtEmlOperatingModeNotification>();
+                            .AddConstructor<MgtEmlOmn>();
     return tid;
 }
 
 TypeId
-MgtEmlOperatingModeNotification::GetInstanceTypeId() const
+MgtEmlOmn::GetInstanceTypeId() const
 {
     return GetTypeId();
 }
 
 void
-MgtEmlOperatingModeNotification::Print(std::ostream& os) const
+MgtEmlOmn::Print(std::ostream& os) const
 {
     os << "EMLSR Mode=" << +m_emlControl.emlsrMode << " EMLMR Mode=" << +m_emlControl.emlmrMode
        << " EMLSR Parameter Update Control=" << +m_emlControl.emlsrParamUpdateCtrl;
@@ -1770,7 +1770,7 @@
 }
 
 uint32_t
-MgtEmlOperatingModeNotification::GetSerializedSize() const
+MgtEmlOmn::GetSerializedSize() const
 {
     uint32_t size = 2; // Dialog Token (1) + first byte of EML Control
     if (m_emlControl.linkBitmap)
@@ -1790,7 +1790,7 @@
 }
 
 void
-MgtEmlOperatingModeNotification::Serialize(Buffer::Iterator start) const
+MgtEmlOmn::Serialize(Buffer::Iterator start) const
 {
     start.WriteU8(m_dialogToken);
 
@@ -1825,7 +1825,7 @@
 }
 
 uint32_t
-MgtEmlOperatingModeNotification::Deserialize(Buffer::Iterator start)
+MgtEmlOmn::Deserialize(Buffer::Iterator start)
 {
     Buffer::Iterator i = start;
 
@@ -1858,7 +1858,7 @@
 }
 
 void
-MgtEmlOperatingModeNotification::SetLinkIdInBitmap(uint8_t linkId)
+MgtEmlOmn::SetLinkIdInBitmap(uint8_t linkId)
 {
     NS_ABORT_MSG_IF(linkId > 15, "Link ID must not exceed 15");
     if (!m_emlControl.linkBitmap)
@@ -1869,7 +1869,7 @@
 }
 
 std::list<uint8_t>
-MgtEmlOperatingModeNotification::GetLinkBitmap() const
+MgtEmlOmn::GetLinkBitmap() const
 {
     std::list<uint8_t> list;
     NS_ASSERT_MSG(m_emlControl.linkBitmap.has_value(), "No link bitmap");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/mgt-headers.h ns-3.40/src/wifi/model/mgt-headers.h
--- ns-3.39/src/wifi/model/mgt-headers.h	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/mgt-headers.h	2023-09-27 13:30:37.910839800 -0700
@@ -121,7 +121,7 @@
                                       std::optional<MultiLinkElement>,
                                       std::optional<EhtCapabilities>,
                                       std::optional<EhtOperation>,
-                                      std::optional<TidToLinkMapping>>;
+                                      std::vector<TidToLinkMapping>>;
 
 /// List of Information Elements included in Association Request frames
 using AssocRequestElems = std::tuple<Ssid,
@@ -133,7 +133,7 @@
                                      std::optional<HeCapabilities>,
                                      std::optional<MultiLinkElement>,
                                      std::optional<EhtCapabilities>,
-                                     std::optional<TidToLinkMapping>>;
+                                     std::vector<TidToLinkMapping>>;
 
 /// List of Information Elements included in Association Response frames
 using AssocResponseElems = std::tuple<SupportedRates,
@@ -150,7 +150,7 @@
                                       std::optional<MultiLinkElement>,
                                       std::optional<EhtCapabilities>,
                                       std::optional<EhtOperation>,
-                                      std::optional<TidToLinkMapping>>;
+                                      std::vector<TidToLinkMapping>>;
 
 /**
  * \ingroup wifi
@@ -1109,10 +1109,10 @@
  * \ingroup wifi
  * Implement the header for Action frames of type EML Operating Mode Notification.
  */
-class MgtEmlOperatingModeNotification : public Header
+class MgtEmlOmn : public Header
 {
   public:
-    MgtEmlOperatingModeNotification() = default;
+    MgtEmlOmn() = default;
 
     /**
      * Register this type.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/mpdu-aggregator.cc ns-3.40/src/wifi/model/mpdu-aggregator.cc
--- ns-3.39/src/wifi/model/mpdu-aggregator.cc	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/mpdu-aggregator.cc	2023-09-27 13:30:37.910839800 -0700
@@ -195,7 +195,7 @@
     hdr.SetLength(mpduSize);
     if (isSingle)
     {
-        hdr.SetEof(1);
+        hdr.SetEof(true);
     }
     return hdr;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/non-ht/dsss-phy.cc ns-3.40/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.39/src/wifi/model/non-ht/dsss-phy.cc	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/non-ht/dsss-phy.cc	2023-09-27 13:30:37.910839800 -0700
@@ -380,7 +380,7 @@
         NS_FATAL_ERROR("Incorrect modulation class, must specify either WIFI_MOD_CLASS_DSSS or "
                        "WIFI_MOD_CLASS_HR_DSSS!");
     }
-    uint16_t numberOfBitsPerSubcarrier = static_cast<uint16_t>(log2(constellationSize));
+    auto numberOfBitsPerSubcarrier = static_cast<uint16_t>(log2(constellationSize));
     uint64_t dataRate = ((11000000 / divisor) * numberOfBitsPerSubcarrier);
     return dataRate;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/non-ht/dsss-ppdu.cc ns-3.40/src/wifi/model/non-ht/dsss-ppdu.cc
--- ns-3.39/src/wifi/model/non-ht/dsss-ppdu.cc	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/non-ht/dsss-ppdu.cc	2023-09-27 13:30:37.910839800 -0700
@@ -80,7 +80,7 @@
 Time
 DsssPpdu::GetTxDuration() const
 {
-    const WifiTxVector& txVector = GetTxVector();
+    const auto& txVector = GetTxVector();
     const auto length = m_dsssSig.GetLength();
     return (MicroSeconds(length) + WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector));
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/non-ht/ofdm-phy.cc ns-3.40/src/wifi/model/non-ht/ofdm-phy.cc
--- ns-3.39/src/wifi/model/non-ht/ofdm-phy.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/non-ht/ofdm-phy.cc	2023-09-27 13:30:37.910839800 -0700
@@ -684,6 +684,25 @@
     return PhyEntity::GetCcaThreshold(ppdu, channelType);
 }
 
+Ptr<const WifiPpdu>
+OfdmPhy::GetRxPpduFromTxPpdu(Ptr<const WifiPpdu> ppdu)
+{
+    const auto txWidth = ppdu->GetTxChannelWidth();
+    const auto& txVector = ppdu->GetTxVector();
+    // Update channel width in TXVECTOR for non-HT duplicate PPDUs.
+    if ((txVector.IsNonHtDuplicate() && (txWidth > m_wifiPhy->GetChannelWidth())))
+    {
+        // We also do a copy of the PPDU for non-HT duplicate PPDUs since other
+        // PHYs might set a different channel width in the reconstructed TXVECTOR.
+        auto rxPpdu = ppdu->Copy();
+        auto updatedTxVector = txVector;
+        updatedTxVector.SetChannelWidth(std::min(txWidth, m_wifiPhy->GetChannelWidth()));
+        rxPpdu->UpdateTxVector(updatedTxVector);
+        return rxPpdu;
+    }
+    return PhyEntity::GetRxPpduFromTxPpdu(ppdu);
+}
+
 } // namespace ns3
 
 namespace
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/non-ht/ofdm-phy.h ns-3.40/src/wifi/model/non-ht/ofdm-phy.h
--- ns-3.39/src/wifi/model/non-ht/ofdm-phy.h	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/non-ht/ofdm-phy.h	2023-09-27 13:30:37.910839800 -0700
@@ -89,6 +89,7 @@
                             Time ppduDuration) override;
     double GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
                            WifiChannelListType channelType) const override;
+    Ptr<const WifiPpdu> GetRxPpduFromTxPpdu(Ptr<const WifiPpdu> ppdu) override;
 
     /**
      * Initialize all OFDM modes (for all variants).
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/non-ht/ofdm-ppdu.cc ns-3.40/src/wifi/model/non-ht/ofdm-ppdu.cc
--- ns-3.39/src/wifi/model/non-ht/ofdm-ppdu.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/non-ht/ofdm-ppdu.cc	2023-09-27 13:30:37.910839800 -0700
@@ -83,7 +83,7 @@
 Time
 OfdmPpdu::GetTxDuration() const
 {
-    const WifiTxVector& txVector = GetTxVector();
+    const auto& txVector = GetTxVector();
     const auto length = m_lSig.GetLength();
     NS_ASSERT(m_operatingChannel.IsSet());
     return WifiPhy::CalculateTxDuration(length, txVector, m_operatingChannel.GetPhyBand());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/phy-entity.cc ns-3.40/src/wifi/model/phy-entity.cc
--- ns-3.39/src/wifi/model/phy-entity.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/phy-entity.cc	2023-09-27 13:30:37.910839800 -0700
@@ -295,7 +295,7 @@
     NS_ABORT_MSG_IF(!supported,
                     "Unknown field "
                         << field << " for this PHY entity"); // TODO see what to do if not supported
-    Time duration = GetDuration(field, event->GetTxVector());
+    Time duration = GetDuration(field, event->GetPpdu()->GetTxVector());
     m_wifiPhy->m_endPhyRxEvent =
         Simulator::Schedule(duration, &PhyEntity::EndReceiveField, this, field, event);
     m_wifiPhy->NotifyCcaBusy(
@@ -310,7 +310,7 @@
     NS_ASSERT(m_wifiPhy); // no sense if no owner WifiPhy instance
     NS_ASSERT(m_wifiPhy->m_endPhyRxEvent.IsExpired());
     PhyFieldRxStatus status = DoEndReceiveField(field, event);
-    WifiTxVector txVector = event->GetTxVector();
+    const auto& txVector = event->GetPpdu()->GetTxVector();
     if (status.isSuccess) // move to next field if reception succeeded
     {
         StartReceiveField(GetNextField(field, txVector.GetPreambleType()), event);
@@ -358,7 +358,7 @@
 Time
 PhyEntity::GetRemainingDurationAfterField(Ptr<const WifiPpdu> ppdu, WifiPpduField field) const
 {
-    const WifiTxVector& txVector = ppdu->GetTxVector();
+    const auto& txVector = ppdu->GetTxVector();
     return ppdu->GetTxDuration() -
            (GetDurationUpToField(field, txVector) + GetDuration(field, txVector));
 }
@@ -586,7 +586,7 @@
     m_signalNoiseMap.insert({std::make_pair(ppdu->GetUid(), staId), SignalNoiseDbm()});
     m_statusPerMpduMap.insert({std::make_pair(ppdu->GetUid(), staId), std::vector<bool>()});
     ScheduleEndOfMpdus(event);
-    const WifiTxVector& txVector = event->GetTxVector();
+    const auto& txVector = event->GetPpdu()->GetTxVector();
     Time payloadDuration = ppdu->GetTxDuration() - CalculatePhyPreambleAndHeaderDuration(txVector);
     m_wifiPhy->m_phyRxPayloadBeginTrace(
         txVector,
@@ -604,7 +604,7 @@
     NS_LOG_FUNCTION(this << *event);
     Ptr<const WifiPpdu> ppdu = event->GetPpdu();
     Ptr<const WifiPsdu> psdu = GetAddressedPsduInPpdu(ppdu);
-    const WifiTxVector& txVector = event->GetTxVector();
+    const auto& txVector = event->GetPpdu()->GetTxVector();
     uint16_t staId = GetStaId(ppdu);
     Time endOfMpduDuration = NanoSeconds(0);
     Time relativeStart = NanoSeconds(0);
@@ -668,8 +668,8 @@
                      Time mpduDuration)
 {
     NS_LOG_FUNCTION(this << *event << mpduIndex << relativeStart << mpduDuration);
-    Ptr<const WifiPpdu> ppdu = event->GetPpdu();
-    WifiTxVector txVector = event->GetTxVector();
+    const auto ppdu = event->GetPpdu();
+    const auto& txVector = ppdu->GetTxVector();
     uint16_t staId = GetStaId(ppdu);
 
     std::pair<bool, SignalNoiseDbm> rxInfo =
@@ -700,13 +700,14 @@
 void
 PhyEntity::EndReceivePayload(Ptr<Event> event)
 {
-    Ptr<const WifiPpdu> ppdu = event->GetPpdu();
-    WifiTxVector txVector = event->GetTxVector();
-    Time psduDuration = ppdu->GetTxDuration() - CalculatePhyPreambleAndHeaderDuration(txVector);
+    const auto ppdu = event->GetPpdu();
+    const auto& txVector = ppdu->GetTxVector();
+    const auto psduDuration =
+        ppdu->GetTxDuration() - CalculatePhyPreambleAndHeaderDuration(txVector);
     NS_LOG_FUNCTION(this << *event << psduDuration);
     NS_ASSERT(event->GetEndTime() == Simulator::Now());
-    uint16_t staId = GetStaId(ppdu);
-    const auto& channelWidthAndBand = GetChannelWidthAndBand(event->GetTxVector(), staId);
+    const auto staId = GetStaId(ppdu);
+    const auto channelWidthAndBand = GetChannelWidthAndBand(txVector, staId);
     double snr = m_wifiPhy->m_interference->CalculateSnr(event,
                                                          channelWidthAndBand.first,
                                                          txVector.GetNss(staId),
@@ -786,7 +787,7 @@
                               Time mpduDuration)
 {
     NS_LOG_FUNCTION(this << *psdu << *event << staId << relativeMpduStart << mpduDuration);
-    const auto& channelWidthAndBand = GetChannelWidthAndBand(event->GetTxVector(), staId);
+    const auto channelWidthAndBand = GetChannelWidthAndBand(event->GetPpdu()->GetTxVector(), staId);
     SnrPer snrPer = m_wifiPhy->m_interference->CalculatePayloadSnrPer(
         event,
         channelWidthAndBand.first,
@@ -794,8 +795,8 @@
         staId,
         std::make_pair(relativeMpduStart, relativeMpduStart + mpduDuration));
 
-    WifiMode mode = event->GetTxVector().GetMode(staId);
-    NS_LOG_DEBUG("rate=" << (mode.GetDataRate(event->GetTxVector(), staId))
+    WifiMode mode = event->GetPpdu()->GetTxVector().GetMode(staId);
+    NS_LOG_DEBUG("rate=" << (mode.GetDataRate(event->GetPpdu()->GetTxVector(), staId))
                          << ", SNR(dB)=" << RatioToDb(snrPer.snr) << ", PER=" << snrPer.per
                          << ", size=" << psdu->GetSize()
                          << ", relativeStart = " << relativeMpduStart.As(Time::NS)
@@ -847,7 +848,6 @@
 Ptr<Event>
 PhyEntity::DoGetEvent(Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW)
 {
-    Ptr<Event> event;
     // We store all incoming preamble events, and a decision is made at the end of the preamble
     // detection window.
     const auto uidPreamblePair = std::make_pair(ppdu->GetUid(), ppdu->GetPreamble());
@@ -857,29 +857,13 @@
     {
         // received another signal with the same content
         NS_LOG_DEBUG("Received another PPDU for UID " << ppdu->GetUid());
-        event = it->second;
-        const auto maxDelay =
-            m_wifiPhy->GetPhyEntityForPpdu(ppdu)->GetMaxDelayPpduSameUid(ppdu->GetTxVector());
-        if (Simulator::Now() - event->GetStartTime() > maxDelay)
-        {
-            // This PPDU arrived too late to be decoded properly. The PPDU is dropped and added as
-            // interference
-            event = CreateInterferenceEvent(ppdu, ppdu->GetTxDuration(), rxPowersW);
-            NS_LOG_DEBUG("Drop PPDU that arrived too late");
-            m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), PPDU_TOO_LATE);
-        }
-        else
-        {
-            // Update received power of the event associated to that transmission
-            UpdateInterferenceEvent(event, rxPowersW);
-        }
+        const auto foundEvent = it->second;
+        HandleRxPpduWithSameContent(foundEvent, ppdu, rxPowersW);
         return nullptr;
     }
-    else
-    {
-        event = CreateInterferenceEvent(ppdu, ppdu->GetTxDuration(), rxPowersW);
-        AddPreambleEvent(event);
-    }
+
+    auto event = CreateInterferenceEvent(ppdu, ppdu->GetTxDuration(), rxPowersW);
+    AddPreambleEvent(event);
     return event;
 }
 
@@ -887,19 +871,41 @@
 PhyEntity::CreateInterferenceEvent(Ptr<const WifiPpdu> ppdu,
                                    Time duration,
                                    RxPowerWattPerChannelBand& rxPower,
-                                   bool isStartOfdmaRxing /* = false */)
+                                   bool isStartHePortionRxing /* = false */)
 {
-    return m_wifiPhy->m_interference->Add(ppdu,
-                                          ppdu->GetTxVector(),
-                                          duration,
-                                          rxPower,
-                                          isStartOfdmaRxing);
+    return m_wifiPhy->m_interference->Add(ppdu, duration, rxPower, isStartHePortionRxing);
 }
 
 void
-PhyEntity::UpdateInterferenceEvent(Ptr<Event> event, const RxPowerWattPerChannelBand& rxPower)
+PhyEntity::HandleRxPpduWithSameContent(Ptr<Event> event,
+                                       Ptr<const WifiPpdu> ppdu,
+                                       RxPowerWattPerChannelBand& rxPower)
 {
+    if (const auto maxDelay =
+            m_wifiPhy->GetPhyEntityForPpdu(ppdu)->GetMaxDelayPpduSameUid(ppdu->GetTxVector());
+        Simulator::Now() - event->GetStartTime() > maxDelay)
+    {
+        // This PPDU arrived too late to be decoded properly. The PPDU is dropped and added as
+        // interference
+        event = CreateInterferenceEvent(ppdu, ppdu->GetTxDuration(), rxPower);
+        NS_LOG_DEBUG("Drop PPDU that arrived too late");
+        m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), PPDU_TOO_LATE);
+        return;
+    }
+
+    // Update received power and TXVECTOR of the event associated to that transmission upon
+    // reception of a signal adding up constructively (in case of a UL MU PPDU or non-HT duplicate
+    // PPDU)
     m_wifiPhy->m_interference->UpdateEvent(event, rxPower);
+    const auto& txVector = ppdu->GetTxVector();
+    const auto& eventTxVector = event->GetPpdu()->GetTxVector();
+    auto updatedTxVector{eventTxVector};
+    updatedTxVector.SetChannelWidth(
+        std::max(eventTxVector.GetChannelWidth(), txVector.GetChannelWidth()));
+    if (updatedTxVector.GetChannelWidth() != eventTxVector.GetChannelWidth())
+    {
+        event->UpdatePpdu(ppdu);
+    }
 }
 
 void
@@ -1048,8 +1054,9 @@
         m_wifiPhy->m_timeLastPreambleDetected = Simulator::Now();
 
         // Continue receiving preamble
-        Time durationTillEnd = GetDuration(WIFI_PPDU_FIELD_PREAMBLE, event->GetTxVector()) -
-                               m_wifiPhy->GetPreambleDetectionDuration();
+        Time durationTillEnd =
+            GetDuration(WIFI_PPDU_FIELD_PREAMBLE, event->GetPpdu()->GetTxVector()) -
+            m_wifiPhy->GetPreambleDetectionDuration();
         m_wifiPhy->NotifyCcaBusy(event->GetPpdu(),
                                  durationTillEnd); // will be prolonged by next field
         m_wifiPhy->m_endPhyRxEvent = Simulator::Schedule(durationTillEnd,
@@ -1333,8 +1340,6 @@
     txParams->duration = txDuration;
     txParams->psd = txPowerSpectrum;
     txParams->ppdu = ppdu;
-    txParams->txWidth = ppdu->GetTxVector().GetChannelWidth();
-    ;
     NS_LOG_DEBUG("Starting " << type << " with power " << txPowerDbm << " dBm on channel "
                              << +m_wifiPhy->GetChannelNumber() << " for "
                              << txParams->duration.As(Time::MS));
@@ -1369,7 +1374,7 @@
 }
 
 bool
-PhyEntity::CanStartRx(Ptr<const WifiPpdu> ppdu, uint16_t txChannelWidth) const
+PhyEntity::CanStartRx(Ptr<const WifiPpdu> ppdu) const
 {
     // The PHY shall not issue a PHY-RXSTART.indication primitive in response to a PPDU that does
     // not overlap the primary channel
@@ -1383,6 +1388,7 @@
     const auto p20MinFreq = p20CenterFreq - (primaryWidth / 2);
     const auto p20MaxFreq = p20CenterFreq + (primaryWidth / 2);
     const auto txCenterFreq = ppdu->GetTxCenterFreq();
+    const auto txChannelWidth = ppdu->GetTxChannelWidth();
     const auto minTxFreq = txCenterFreq - txChannelWidth / 2;
     const auto maxTxFreq = txCenterFreq + txChannelWidth / 2;
     return p20MinFreq >= minTxFreq && p20MaxFreq <= maxTxFreq;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/phy-entity.h ns-3.40/src/wifi/model/phy-entity.h
--- ns-3.39/src/wifi/model/phy-entity.h	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/phy-entity.h	2023-09-27 13:30:37.910839800 -0700
@@ -31,7 +31,6 @@
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
 #include "ns3/simple-ref-count.h"
-#include "ns3/wifi-spectrum-value-helper.h"
 
 #include <list>
 #include <map>
@@ -458,11 +457,10 @@
      * given PPDU.
      *
      * \param ppdu the PPDU
-     * \param txChannelWidth the channel width (MHz) used to transmit the PPDU
      * \return true if the PHY shall issue a PHY-RXSTART.indication primitive in response to a PPDU,
      * false otherwise
      */
-    virtual bool CanStartRx(Ptr<const WifiPpdu> ppdu, uint16_t txChannelWidth) const;
+    virtual bool CanStartRx(Ptr<const WifiPpdu> ppdu) const;
 
     /**
      * Check if PHY state should move to CCA busy state based on current
@@ -839,22 +837,30 @@
      * \param ppdu the PPDU
      * \param duration the PPDU duration
      * \param rxPower received power per band (W)
-     * \param isStartOfdmaRxing flag whether the event corresponds to the start of the OFDMA payload
-     * reception (only used for UL-OFDMA)
-     * \return the created event
+     * \param isStartHePortionRxing flag whether the event corresponds to the start of the OFDMA
+     * payload reception (only used for UL-OFDMA) \return the created event
      */
     Ptr<Event> CreateInterferenceEvent(Ptr<const WifiPpdu> ppdu,
                                        Time duration,
                                        RxPowerWattPerChannelBand& rxPower,
-                                       bool isStartOfdmaRxing = false);
+                                       bool isStartHePortionRxing = false);
     /**
-     * Update an event in WifiPhy's InterferenceHelper class.
-     * Wrapper used by child classes.
-     *
-     * \param event the event to be updated
-     * \param rxPower the received power (W) per band to be added to the current event
-     */
-    void UpdateInterferenceEvent(Ptr<Event> event, const RxPowerWattPerChannelBand& rxPower);
+     * Handle reception of a PPDU that carries the same content of another PPDU.
+     * This is typically called upon reception of preambles of HE MU PPDUs or reception
+     * of non-HT duplicate control frames that carries the exact same content sent from different
+     * STAs. If the delay between the PPDU and the first PPDU carrying the same content is small
+     * enough, PPDU can be decoded and its power is added constructively, and the TXVECTOR is
+     * updated accordingly. Otherwise, a new interference event is created and PPDU is dropped by
+     * the PHY.
+     *
+     * \param event the event of the ongoing reception
+     * \param ppdu the newly received PPDU (UL MU or non-HT duplicate)
+     * \param rxPower the received power (W) per band of the newly received PPDU
+     */
+    virtual void HandleRxPpduWithSameContent(Ptr<Event> event,
+                                             Ptr<const WifiPpdu> ppdu,
+                                             RxPowerWattPerChannelBand& rxPower);
+
     /**
      * Notify WifiPhy's InterferenceHelper of the end of the reception,
      * clear maps and end of MPDU event, and eventually reset WifiPhy.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/qos-frame-exchange-manager.cc ns-3.40/src/wifi/model/qos-frame-exchange-manager.cc
--- ns-3.39/src/wifi/model/qos-frame-exchange-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/qos-frame-exchange-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -99,15 +99,15 @@
 
     WifiTxVector cfEndTxVector = GetWifiRemoteStationManager()->GetRtsTxVector(cfEnd.GetAddr1());
 
-    Time txDuration = m_phy->CalculateTxDuration(cfEnd.GetSize() + WIFI_MAC_FCS_LENGTH,
-                                                 cfEndTxVector,
-                                                 m_phy->GetPhyBand());
+    auto mpdu = Create<WifiMpdu>(Create<Packet>(), cfEnd);
+    auto txDuration =
+        m_phy->CalculateTxDuration(mpdu->GetSize(), cfEndTxVector, m_phy->GetPhyBand());
 
     // Send the CF-End frame if the remaining duration is long enough to transmit this frame
     if (m_edca->GetRemainingTxop(m_linkId) > txDuration)
     {
         NS_LOG_DEBUG("Send CF-End frame");
-        m_phy->Send(Create<WifiPsdu>(Create<Packet>(), cfEnd), cfEndTxVector);
+        ForwardMpduDown(mpdu, cfEndTxVector);
         Simulator::Schedule(txDuration,
                             &QosFrameExchangeManager::NotifyChannelReleased,
                             this,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/qos-txop.cc ns-3.40/src/wifi/model/qos-txop.cc
--- ns-3.39/src/wifi/model/qos-txop.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/qos-txop.cc	2023-09-27 13:30:37.910839800 -0700
@@ -640,9 +640,9 @@
         m_baManager->NotifyOriginatorAgreementRejected(recipient, tid);
     }
 
-    for (uint8_t linkId = 0; linkId < GetNLinks(); linkId++)
+    for (const auto& [id, link] : GetLinks())
     {
-        StartAccessIfNeeded(linkId);
+        StartAccessIfNeeded(id);
     }
 }
 
@@ -662,9 +662,9 @@
     m_baManager->NotifyOriginatorAgreementNoReply(recipient, tid);
     // the recipient has been "unblocked" and transmissions can resume using normal
     // acknowledgment, hence start access (if needed) on all the links
-    for (uint8_t linkId = 0; linkId < GetNLinks(); linkId++)
+    for (const auto& [id, link] : GetLinks())
     {
-        StartAccessIfNeeded(linkId);
+        StartAccessIfNeeded(id);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/aarfcd-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/aarfcd-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/aarfcd-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/aarfcd-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -151,7 +151,7 @@
 AarfcdWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    AarfcdWifiRemoteStation* station = new AarfcdWifiRemoteStation();
+    auto station = new AarfcdWifiRemoteStation();
 
     // AARF fields below
     station->m_successThreshold = m_minSuccessThreshold;
@@ -182,7 +182,7 @@
 AarfcdWifiManager::DoReportDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    AarfcdWifiRemoteStation* station = static_cast<AarfcdWifiRemoteStation*>(st);
+    auto station = static_cast<AarfcdWifiRemoteStation*>(st);
     station->m_timer++;
     station->m_failed++;
     station->m_success = 0;
@@ -269,7 +269,7 @@
                                  double rtsSnr)
 {
     NS_LOG_FUNCTION(this << st << ctsSnr << ctsMode << rtsSnr);
-    AarfcdWifiRemoteStation* station = static_cast<AarfcdWifiRemoteStation*>(st);
+    auto station = static_cast<AarfcdWifiRemoteStation*>(st);
     NS_LOG_DEBUG("station=" << station << " rts ok");
     station->m_rtsCounter--;
 }
@@ -283,7 +283,7 @@
                                   uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
-    AarfcdWifiRemoteStation* station = static_cast<AarfcdWifiRemoteStation*>(st);
+    auto station = static_cast<AarfcdWifiRemoteStation*>(st);
     station->m_timer++;
     station->m_success++;
     station->m_failed = 0;
@@ -328,7 +328,7 @@
 AarfcdWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    AarfcdWifiRemoteStation* station = static_cast<AarfcdWifiRemoteStation*>(st);
+    auto station = static_cast<AarfcdWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
@@ -359,7 +359,7 @@
     NS_LOG_FUNCTION(this << st);
     /// \todo we could/should implement the AARF algorithm for
     /// RTS only by picking a single rate within the BasicRateSet.
-    AarfcdWifiRemoteStation* station = static_cast<AarfcdWifiRemoteStation*>(st);
+    auto station = static_cast<AarfcdWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
@@ -390,7 +390,7 @@
 AarfcdWifiManager::DoNeedRts(WifiRemoteStation* st, uint32_t size, bool normally)
 {
     NS_LOG_FUNCTION(this << st << size << normally);
-    AarfcdWifiRemoteStation* station = static_cast<AarfcdWifiRemoteStation*>(st);
+    auto station = static_cast<AarfcdWifiRemoteStation*>(st);
     NS_LOG_INFO("" << station << " rate=" << station->m_rate
                    << " rts=" << (station->m_rtsOn ? "RTS" : "BASIC")
                    << " rtsCounter=" << station->m_rtsCounter);
